"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import dateutil.parser
from ..shared import address as shared_address
from ..shared import attachment as shared_attachment
from ..shared import customer_read as shared_customer_read
from ..shared import merchant_urls as shared_merchant_urls
from ..shared import options as shared_options
from ..shared import order_line as shared_order_line
from ..shared import payment_method_category as shared_payment_method_category
from dataclasses_json import Undefined, dataclass_json
from datetime import datetime
from enum import Enum
from klarna import utils
from marshmallow import fields
from typing import Optional

class SessionReadAcquiringChannelEnum(str, Enum):
    r"""The acquiring channel in which the session takes place. Ecommerce is default unless specified. Any other values should be defined in the agreement."""
    ECOMMERCE = 'ECOMMERCE'
    IN_STORE = 'IN_STORE'
    TELESALES = 'TELESALES'

class SessionReadIntentEnum(str, Enum):
    r"""Intent for the session. The field is designed to let partners inform Klarna of the purpose of the customer’s session."""
    BUY = 'buy'
    TOKENIZE = 'tokenize'
    BUY_AND_TOKENIZE = 'buy_and_tokenize'

class SessionReadStatusEnum(str, Enum):
    r"""The current status of the session. Possible values: 'complete', 'incomplete' where 'complete' is set when the order has been placed."""
    COMPLETE = 'complete'
    INCOMPLETE = 'incomplete'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SessionRead:
    r"""successful operation"""
    
    acquiring_channel: Optional[SessionReadAcquiringChannelEnum] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('acquiring_channel'), 'exclude': lambda f: f is None }})
    r"""The acquiring channel in which the session takes place. Ecommerce is default unless specified. Any other values should be defined in the agreement."""
    attachment: Optional[shared_attachment.Attachment] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('attachment'), 'exclude': lambda f: f is None }})
    authorization_token: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('authorization_token'), 'exclude': lambda f: f is None }})
    r"""Authorization token."""
    billing_address: Optional[shared_address.Address] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('billing_address'), 'exclude': lambda f: f is None }})
    client_token: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_token'), 'exclude': lambda f: f is None }})
    r"""Token to be passed to the JS client"""
    custom_payment_method_ids: Optional[list[str]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('custom_payment_method_ids'), 'exclude': lambda f: f is None }})
    r"""Promo codes - The array could be used to define which of the configured payment options within a payment category (pay_later, pay_over_time, etc.) should be shown for this purchase. Discuss with the delivery manager to know about the promo codes that will be configured for your account. The feature could also be used to provide promotional offers to specific customers (eg: 0% financing). Please be informed that the usage of this feature can have commercial implications."""
    customer: Optional[shared_customer_read.CustomerRead] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('customer'), 'exclude': lambda f: f is None }})
    design: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('design'), 'exclude': lambda f: f is None }})
    r"""Design package to use in the session. This can only by used if a custom design has been implemented for Klarna Payments and agreed upon in the agreement. It might have a financial impact. Delivery manager will provide the value for the parameter."""
    expires_at: Optional[datetime] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('expires_at'), 'encoder': utils.datetimeisoformat(True), 'decoder': dateutil.parser.isoparse, 'mm_field': fields.DateTime(format='iso'), 'exclude': lambda f: f is None }})
    r"""Session expiration date"""
    intent: Optional[SessionReadIntentEnum] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('intent'), 'exclude': lambda f: f is None }})
    r"""Intent for the session. The field is designed to let partners inform Klarna of the purpose of the customer’s session."""
    locale: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('locale'), 'exclude': lambda f: f is None }})
    r"""Used to define the language and region of the customer. The locale follows the format of [RFC 1766](https://datatracker.ietf.org/doc/rfc1766/), meaning its value consists of language-country.
    Read more on **[Supported Locals and Currencies](https://docs.klarna.com/klarna-payments/in-depth-knowledge/puchase-countries-currencies-locales/)**.
    """
    merchant_data: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('merchant_data'), 'exclude': lambda f: f is None }})
    r"""Pass through field to send any information about the order to be used later for reference while retrieving the order details (max 6000 characters)"""
    merchant_reference1: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('merchant_reference1'), 'exclude': lambda f: f is None }})
    r"""Used for storing merchant's internal order number or other reference."""
    merchant_reference2: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('merchant_reference2'), 'exclude': lambda f: f is None }})
    r"""Used for storing merchant's internal order number or other reference. The value is available in the settlement files. (max 255 characters)."""
    merchant_urls: Optional[shared_merchant_urls.MerchantUrls] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('merchant_urls'), 'exclude': lambda f: f is None }})
    options: Optional[shared_options.Options] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('options'), 'exclude': lambda f: f is None }})
    order_amount: Optional[int] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('order_amount'), 'exclude': lambda f: f is None }})
    r"""Total amount of the order including tax and any available discounts. The value should be in non-negative minor units. Eg: 25 Euros should be 2500."""
    order_lines: Optional[list[shared_order_line.OrderLine]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('order_lines'), 'exclude': lambda f: f is None }})
    r"""The array containing list of line items that are part of this order. Maximum of 1000 line items could be processed in a single order."""
    order_tax_amount: Optional[int] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('order_tax_amount'), 'exclude': lambda f: f is None }})
    r"""Total tax amount of the order. The value should be in non-negative minor units. Eg: 25 Euros should be 2500."""
    payment_method_categories: Optional[list[shared_payment_method_category.PaymentMethodCategory]] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('payment_method_categories'), 'exclude': lambda f: f is None }})
    r"""Available payment method categories"""
    purchase_country: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('purchase_country'), 'exclude': lambda f: f is None }})
    r"""The purchase country of the customer. The billing country always overrides purchase country if the values are different. Formatted according to ISO 3166 alpha-2 standard, e.g. GB, SE, DE, US, etc."""
    purchase_currency: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('purchase_currency'), 'exclude': lambda f: f is None }})
    r"""The purchase currency of the order. Formatted according to ISO 4217 standard, e.g. USD, EUR, SEK, GBP, etc."""
    shipping_address: Optional[shared_address.Address] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('shipping_address'), 'exclude': lambda f: f is None }})
    status: Optional[SessionReadStatusEnum] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('status'), 'exclude': lambda f: f is None }})
    r"""The current status of the session. Possible values: 'complete', 'incomplete' where 'complete' is set when the order has been placed."""
    